#ifndef _DrvADC1_h_
#define _DrvADC1_h_
#include "stm32f10x_adc.h"
#include "stm32f10x_dma.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"
#include "misc.h"
#include "Api.h"
#include <string.h>

/*-----------------------------ֲĶ-----------------------------------*/

//#define ADC_DMA				//DMAģʽ, Ϊעģʽ(Ϊ·)

#define ADCx_SAMPLE_COUNT		10u						//ͨɵĵ


#define ADCx 					ADC1					//ʹõADC
#define ADCx_DR_Address    		((u32)0x4001244C)
#define RCC_APBXPeriph_ADCx	RCC_APB2Periph_ADC1		//ADC1ʱ
#define ADC_SampleTime 			ADC_SampleTime_71Cycles5//ADCβʱ䳤

#define RCC_AHBPeriph_DMAx		RCC_AHBPeriph_DMA1		//DMA1ʱ
#define DMAx_Channelx			DMA1_Channel1

#define RCC_APBXPeriph_GPIOX_1	RCC_APB2Periph_GPIOA	//
#define RCC_APBXPeriph_GPIOX_2	RCC_APB2Periph_GPIOB	//
#define RCC_APBXPeriph_GPIOX_3	RCC_APB2Periph_GPIOC	//

#define ADCx_GPIOX_1	 		GPIOA
#define ADCx_GPIOX_2			GPIOB
#define ADCx_GPIOX_3			GPIOC

#define ADCx_IRQHandler			ADC1_2_IRQHandler
#define ADCx_IRQChannel			ADC1_2_IRQn

//ע עģʽ 4·ͨ
#define ADCx_CHANNEL0_EN		0	//ADCxͨ1  1:ܣ0:ʧ
#define ADCx_CHANNEL1_EN		0	//ADCxͨ2  1:ܣ0:ʧ
#define ADCx_CHANNEL2_EN		0	//ADCxͨ3  1:ܣ0:ʧ
#define ADCx_CHANNEL3_EN		0	//ADCxͨ4  1:ܣ0:ʧ
#define ADCx_CHANNEL4_EN		0	//ADCxͨ5  1:ܣ0:ʧ
#define ADCx_CHANNEL5_EN		0	//ADCxͨ6  1:ܣ0:ʧ
#define ADCx_CHANNEL6_EN		0	//ADCxͨ7  1:ܣ0:ʧ
#define ADCx_CHANNEL7_EN		0	//ADCxͨ8  1:ܣ0:ʧ
#define ADCx_CHANNEL8_EN		0	//ADCxͨ9  1:ܣ0:ʧ
#define ADCx_CHANNEL9_EN		0	//ADCxͨ10  1:ܣ0:ʧ
#define ADCx_CHANNEL10_EN		1	//ADCxͨ11  1:ܣ0:ʧ
#define ADCx_CHANNEL11_EN		1	//ADCxͨ12  1:ܣ0:ʧ
#define ADCx_CHANNEL12_EN		1	//ADCxͨ13  1:ܣ0:ʧ
#define ADCx_CHANNEL13_EN		1	//ADCxͨ14  1:ܣ0:ʧ
#define ADCx_CHANNEL14_EN		0	//ADCxͨ15  1:ܣ0:ʧ
#define ADCx_CHANNEL15_EN		0	//ADCxͨ16  1:ܣ0:ʧ

#define ADCxInstall				ADC1Install
#define ADCxNuinstall				ADC1Nuinstall
/*----------------------------------------------------------------------------*/

#define ADCx_GPIOX_PIN_CH0		GPIO_Pin_0				//ͨ˿GPIOX_1
#define ADCx_GPIOX_PIN_CH1		GPIO_Pin_1				//ͨ˿GPIOX_1
#define ADCx_GPIOX_PIN_CH2		GPIO_Pin_2				//ͨ˿GPIOX_1
#define ADCx_GPIOX_PIN_CH3		GPIO_Pin_3				//ͨ˿GPIOX_2
#define ADCx_GPIOX_PIN_CH4		GPIO_Pin_4				//ͨ˿GPIOX_2
#define ADCx_GPIOX_PIN_CH5		GPIO_Pin_5				//ͨ˿GPIOX_1
#define ADCx_GPIOX_PIN_CH6		GPIO_Pin_6				//ͨ˿GPIOX_1
#define ADCx_GPIOX_PIN_CH7		GPIO_Pin_7				//ͨ˿GPIOX_2
#define ADCx_GPIOX_PIN_CH8		GPIO_Pin_8				//ͨ˿GPIOX_2
#define ADCx_GPIOX_PIN_CH9		GPIO_Pin_9				//ͨ˿GPIOX_1
#define ADCx_GPIOX_PIN_CH10	GPIO_Pin_10				//ͨ˿GPIOX_1
#define ADCx_GPIOX_PIN_CH11	GPIO_Pin_11				//ͨ˿GPIOX_2
#define ADCx_GPIOX_PIN_CH12	GPIO_Pin_12				//ͨ˿GPIOX_2
#define ADCx_GPIOX_PIN_CH13	GPIO_Pin_13				//ͨ˿GPIOX_1
#define ADCx_GPIOX_PIN_CH14	GPIO_Pin_14				//ͨ˿GPIOX_1
#define ADCx_GPIOX_PIN_CH15	GPIO_Pin_15				//ͨ˿GPIOX_1


//ܶ˿
#define CHANNEL_COUNT		(ADCx_CHANNEL0_EN + ADCx_CHANNEL1_EN + \
							ADCx_CHANNEL2_EN + ADCx_CHANNEL3_EN + \
							ADCx_CHANNEL4_EN + ADCx_CHANNEL5_EN + \
							ADCx_CHANNEL6_EN + ADCx_CHANNEL7_EN + \
							ADCx_CHANNEL8_EN + ADCx_CHANNEL9_EN + \
							ADCx_CHANNEL10_EN + ADCx_CHANNEL11_EN + \
							ADCx_CHANNEL12_EN + ADCx_CHANNEL13_EN + \
							ADCx_CHANNEL14_EN + ADCx_CHANNEL15_EN )
//						
#define ADCx_GPIOX_1_EN	(ADCx_CHANNEL0_EN + ADCx_CHANNEL1_EN + \
							ADCx_CHANNEL2_EN + ADCx_CHANNEL3_EN + \
							ADCx_CHANNEL4_EN + ADCx_CHANNEL5_EN + \
							ADCx_CHANNEL6_EN + ADCx_CHANNEL7_EN)

#define ADCx_GPIOX_2_EN	(ADCx_CHANNEL8_EN + ADCx_CHANNEL9_EN)

#define ADCx_GPIOX_3_EN	(ADCx_CHANNEL10_EN + ADCx_CHANNEL11_EN + \
							ADCx_CHANNEL12_EN + ADCx_CHANNEL13_EN + \
							ADCx_CHANNEL14_EN + ADCx_CHANNEL15_EN )


#define ORDER_CH0			ADCx_CHANNEL0_EN
#define ORDER_CH1			(ADCx_CHANNEL1_EN + ORDER_CH0)
#define ORDER_CH2			(ADCx_CHANNEL2_EN + ORDER_CH1)
#define ORDER_CH3			(ADCx_CHANNEL3_EN + ORDER_CH2)
#define ORDER_CH4			(ADCx_CHANNEL4_EN + ORDER_CH3)
#define ORDER_CH5			(ADCx_CHANNEL5_EN + ORDER_CH4)
#define ORDER_CH6			(ADCx_CHANNEL6_EN + ORDER_CH5)
#define ORDER_CH7			(ADCx_CHANNEL7_EN + ORDER_CH6)
#define ORDER_CH8			(ADCx_CHANNEL8_EN + ORDER_CH7)
#define ORDER_CH9			(ADCx_CHANNEL9_EN + ORDER_CH8)
#define ORDER_CH10			(ADCx_CHANNEL10_EN + ORDER_CH9)
#define ORDER_CH11			(ADCx_CHANNEL11_EN + ORDER_CH10)
#define ORDER_CH12			(ADCx_CHANNEL12_EN + ORDER_CH11)
#define ORDER_CH13			(ADCx_CHANNEL13_EN + ORDER_CH12)
#define ORDER_CH14			(ADCx_CHANNEL14_EN + ORDER_CH13)
#define ORDER_CH15			(ADCx_CHANNEL15_EN + ORDER_CH14)

#define MAX_AD_SAMPLE_COUNTER (ADCx_SAMPLE_COUNT * CHANNEL_COUNT)



//-------------------------------------------------------------------------------------------




/*******************************************************************************
* Description   :ADCxʼ
* Input         :Ч  NULL
*******************************************************************************/
static INT32S ADCxOpen(void *pd);
/*******************************************************************************
* Description   :ʧ򿪵ADCģʽ
* Input         :Ч
*******************************************************************************/
static INT32S ADCxClose(void *pd);
/*******************************************************************************
* Description   :ȡ
* Input         :*buffer:塣lenToRead:ȡ(λֽ) Ч
*******************************************************************************/
static INT32S ADCxRead(INT8S *buffer, INT32U blen, INT32U lenToRead, INT8U waitType);
/*******************************************************************************
* Description   :ADCX
* Input         :too: 	*pd
*				 0		u16	жȼ8λռȼ8λȼ
*				 1				ʼAD Զֹͣ仺
*				 2 				ֹͣAD
*				 3 				ʼȴ ֹͣ(UCOSII ϵͳ)
*******************************************************************************/
static INT32S ADCxIoCtl(INT32U too, void *pd);







INT32S ADCxInstall(UDFOperationsType *op);
INT32S ADCxNuinstall(UDFOperationsType *op);





#endif



