
#ifndef _DrvFlash_h_
#define _DrvFlash_h_


#include "stm32f10x_flash.h"
#include "Api.h"




#define BANK1_WRITE_START_ADDR  ((uint32_t)0x0803D000)	//ŵʼַ
#define BANK1_WRITE_END_ADDR    ((uint32_t)0x0803E000)	//ŵַ
#define BANK1_USE_LEN_ADDR	(BANK1_WRITE_END_ADDR - BANK1_WRITE_START_ADDR)


#define FlashInstall		FlashInstall
#define FlashNuinstall 	FlashNuinstall

/*----------------------------------------------------------------------------*/

/*******************************************************************************
* Description   :FLASH  Bank1
* Input         :Ч
*******************************************************************************/
static INT32S FlashOpen(void *pd);
/*******************************************************************************
* Description   :FLASH  Bank1
* Input         :Ч
*******************************************************************************/
static INT32S FlashClose(void *pd);
/*******************************************************************************
* Description   :дFLASH
* Input         :*buffer:塣lenToWrite:ݵĳ(ֽ)
*******************************************************************************/
static INT32S FlashWrite(INT8S *buffer, INT32U lenToWrite, INT8U waitType);
/*******************************************************************************
* Description	:FLASHд洢
* Input 		:*buffer:塣lenToRead:ݵĳ(ֽ)
*******************************************************************************/
static INT32S FlashRead(INT8S *buffer, INT32U blen, INT32U lenToRead, INT8U waitType);


INT32S FlashInstall(UDFOperationsType *op);
INT32S FlashNuinstall(UDFOperationsType *op);



#endif

