/*-------------------------------------------------------------------------

						I2C1ͷļ
    				
-------------------------------------------------------------------------*/
    
#ifndef _DrvI2Cx_h_
#define _DrvI2Cx_h_


#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"
#include "stm32f10x_i2c.h"
#include "misc.h"

#include "Api.h"
#include <string.h>
#include <math.h>


/*----------------------------------------------------------------------------*/
#define I2Cx                        I2C1
#define RCC_APBXPeriph_I2C          RCC_APB1Periph_I2C1
#define RCC_APBXPeriph_GPIOX_SCL    RCC_APB2Periph_GPIOB//
#define RCC_APBXPeriph_GPIOX_SDA    RCC_APB2Periph_GPIOB//

#define GPIOX_SCL                   GPIOB
#define GPIOX_SDA                   GPIOB

#define GPIOX_PIN_SCL               GPIO_Pin_6				//оƬж
#define GPIOX_PIN_SDA               GPIO_Pin_7				//оƬʹ

#define I2Cx_EV_IRQn                I2C1_EV_IRQn
#define I2Cx_EV_IRQHandler          I2C1_EV_IRQHandler

#define I2CxInstall                 I2C1Install
#define I2CxNuinstall               I2C1Nuinstall

/*----------------------------------------------------------------------------*/
#define ClockSpeed			        400000
#define I2Cx_ADDRESS1		        0x21


#define  I2Cx_SLAVE_ADDRESS7	    I2Cx_ADDRESS1





extern void Delay(volatile CPU_INT32U nCount);

#define RD 1                //
#define WR 0                //д
#define BUFF_LENGTH 10      //
typedef struct {
	vu8 buf[BUFF_LENGTH];   //
	vu16 index;             //Ȼ
	vu16 len;               //ݳ
	vu8 r_w;                ///д
	vu8 rFlag;              //־
	vu8 wFlag;              //д־
}I2CxType;
#define I2CxDefault() {     \
	{0,},                   \
	0,                      \
	0,                      \
	0,                      \
	0,                      \
	0,                      \
}


static void I2CxPrioritySet(INT16U level);

INT32S I2CxInstall(UDFOperationsType *op);
INT32S I2CxNuinstall(UDFOperationsType *op);



#endif

