/****************************************Copyright (c)**************************************************
**                                  Զ޹˾
**
**                                 http://www.21cm.com.cn
**
**
**--------------File Info-------------------------------------------------------------------------------
** File name:			MBCommon.c
** Last modified Date:  2005-01-11
** Last Version:		1.0
** Descriptions:		
**
**------------------------------------------------------------------------------------------------------
** Created by:			ZhouLishan
** Created date:		2005-01-11
** Version:				1.0
** Descriptions:		
**
**------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
** Version:
** Descriptions:
**
********************************************************************************************************/

#include "MBConfig.h"


PDU_HANDLE 				PDUData;
volatile ADU_CONTROL 	ADUData;

#ifdef UCOSIII
extern 	OS_SEM mb_handle_event_ptr;
static	OS_ERR err;
#endif

extern uint16 Modbus_CRC16(uint8 *Buff_addr,int16 len);

//********************************************************************************************************
// ƣStartCountT15
// 
// 
// ʹT1.5T1.5ʱֵΪUART1.5ַʱ䡣
//			 ע⣺úֻʹܼʱںвκʱ
//			       T1.5ʱִT15EndHandle
//********************************************************************************************************
extern void StartCountT15(void); 

//********************************************************************************************************
// ƣStartCountT35
// 
// 
// ʹT3.5T3.5ʱֵΪUART3.5ַʱ䡣
//			 ע⣺úֻʹܼʱںвκʱ
//			       T3.5ʱִT35EndHandle
//********************************************************************************************************
extern void StartCountT35(void);


volatile uint32 g_10mS_count;
volatile uint8 	g_TimeEnd;				// Ӧʱ
//******************************************************************************************
// ƣGet_10mS
// 
// 10mSĴ
// ȡ10mSֵֵÿ101
//******************************************************************************************
void Waite10mS(uint32 time)
{
	g_TimeEnd = FALSE;
	g_10mS_count=time;
}



//*****************************************************************************
// ƣOverTimeHandle
// 
// 
// 
//*****************************************************************************
void Time10mSHandle(void)
{
	if(g_10mS_count==0)	return; // g_10mS_count,ֵΪ0ʾûм¼,ֱӷ
	g_10mS_count--;				// 1,ֱӵ0Ϊֱ
	if(g_10mS_count==0)
	{	g_TimeEnd = TRUE;
	#ifdef UCOSIII
		OSSemPost(	(OS_SEM		*)&mb_handle_event_ptr,
					(OS_OPT		)OS_OPT_POST_NO_SCHED,
					(OS_ERR		*)&err	);				// ź,ʹMODBUS
	#endif
	}
}

//********************************************************************************************************
// ƣT15EndHandle
// 
// 
// T1.5ʱ
//********************************************************************************************************
void T15EndHandle(void)
{
	uint16 RedundancyCheck;
	if(ADUData.EndT15)
		return;
	ADUData.EndT15 = TRUE;		// T1.5ʱ	

	if((*ADUData.ADUBuffPtr==BROADCAST_ADDRESS)||		// ַ֤ǷЧ
	   (*ADUData.ADUBuffPtr==ADUData.Address))
	{
		RedundancyCheck = *(ADUData.ADUBuffPtr+ADUData.ADULength-2) |
								  (*(ADUData.ADUBuffPtr+ADUData.ADULength-1) << 8);

		if(RedundancyCheck == Modbus_CRC16(ADUData.ADUBuffPtr,ADUData.ADULength-2))	// CRCУ
		{
			ADUData.FrameOK = TRUE;
			return;
		}
	}
	ADUData.FrameOK = FALSE;
	
}

//********************************************************************************************************
// ƣT35EndHandle
// 
// 
// T3.5
//********************************************************************************************************
void T35EndHandle(void)
{

	if(ADUData.FrameOK)
	{
		PDUData.PDUBuffPtr = ADUData.ADUBuffPtr+1;
		PDUData.PDULength = ADUData.ADULength-3;
		PDUData.FunctionCode = *PDUData.PDUBuffPtr; // 湦ܴ
		PDUData.FrameOK=TRUE;
	}
	else
	{
		PDUData.FrameOK=FALSE;
	}
   	ADUData.EndT15 = FALSE;		// յַ
	ADUData.ADULength = 0;
#ifdef UCOSIII
	OSSemPost(	(OS_SEM		*)&mb_handle_event_ptr,
				(OS_OPT		)OS_OPT_POST_NO_SCHED,
				(OS_ERR		*)&err	);		// ź,ʹMODBUS
#endif
}

 
//********************************************************************************************************
// ƣReceOneChar
// ReceCharacter
// 
// һַ
//           Ҫ:յһַú
//********************************************************************************************************
void ReceOneChar(uint8 ReceCharacter)
{

	if(ADUData.EndT15==TRUE)
	{	
		StartCountT35();			// T3.5ʱ
		return;
	}
	ADUData.FrameOK = FALSE;
	StartCountT15();			// T1.5ʱ
	StartCountT35();			// T3.5ʱ

   	*(ADUData.ADUBuffPtr + ADUData.ADULength) = ReceCharacter;
	ADUData.ADULength++; 
}

//********************************************************************************************************
// ƣPutCharInPUD
// ch,дַ
//			 EndChar
// 
// һַ
//           Ҫ:յһַú
//********************************************************************************************************
uint8 PutDataInPUD(uint8 *CharPtr,uint16 Length)
{
	uint16 i;
	if(Length<=MAX_PDU_DATA_LENGTH)
	{
		for(i=0;i<Length;i++)
			*(PDUData.PDUBuffPtr+i)=*(CharPtr+i);
		PDUData.PDULength = Length ;
		PDUData.FrameOK = TRUE;
		return TRUE;
	}
	else
		return FALSE;
}


/*********************************************************************************************************
**                            OSModbusServe MODBUS
********************************************************************************************************/

void OSModbusServe	(void *pdata)
{	
#ifdef UCOSIII
	while (1)
	{	
		IdleModbus();
	}
#else
	IdleModbus();
#endif	
}   




