/****************************************Copyright (c)**************************************************
**                                  Զ޹˾
**
**                                 http://www.21cm.com.cn
**
**--------------ļϢ--------------------------------------------------------------------------------
**      : syshal.c
**      : ɽ
**޸: 2006223
**        : ModbusMagicARM2410Ͳֲļ
**                
**--------------ļϢ--------------------------------------------------------------------------------
**      : syshal.c
**      : ǿ
**޸: 2012521
**        : Modbusstm32f103Ͳֲļ
**				
**				ռTIM4ʱ usart1 Ҫͨöʱʱ ֱCtrl+H滻TIM4		
**
**				
**------------------------------------------------------------------------------------------------------
********************************************************************************************************/

#include <stm32f10x_tim.h>
#include <stm32f10x_rcc.h>
#include <misc.h>
#include "MBConfig.h"
#include "Api.h"


static volatile uint16 timeCount = 0;
static DEV_Handle _hUsart1;


/*********************************************************************************************************
** Function name: SendResponse
** Descriptions:  ֡ΪײַʹZLG/MODBUS RTUЭջʹøú֡ݡ
** Input: buffַָ룬ͣunsigned char
**        lenַȣͣunsigned short     
** Output:        
** Created by:    ɽ
** Created Date:  2006-02-21
**-------------------------------------------------------------------------------------------------------
** Modified by:
** Modified Date: 
**------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void SendResponse(uint8 *buff,uint16 len)
{
	UDFWrite(_hUsart1, (INT8S *)buff, len, 0);	
}

/*******************************************************************************
* Function Name :void MBTimersActive(FunctionalState stat)
* Description   :modbusЭ鶨ʱ رա
* Input         :stat:ENABLE :
* Output        :
* Other         :
* Date          :2012.05.21  13:52:36
*******************************************************************************/
void MBTimersActive(FunctionalState stat)
{
	TIM_SetCounter(TIM4, 0);
	TIM_ITConfig(TIM4, TIM_IT_Update, stat);
	TIM_Cmd(TIM4, stat);
}


/*********************************************************************************************************
** Function name: StartCountT15
** Descriptions:  ʹT1.5T1.5ʱֵΪUART1.5ַʱ䡣
**			      ע⣺úֻʹܼʱںвκʱ
**			            T1.5ʱִT15EndHandle
** Input:       
** Output:        
** Created by:    ɽ
** Created Date:  2006-02-21
**-------------------------------------------------------------------------------------------------------
** Modified by:
** Modified Date: 
**------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void StartCountT15(void)
{
	timeCount = 0;
	MBTimersActive(ENABLE);
}


/*********************************************************************************************************
** Function name: StartCountT35
** Descriptions:  ʹT3.5T3.5ʱֵΪUART3.5ַʱ䡣
**			      ע⣺úֻʹܼʱںвκʱ
**			             T3.5ʱִT35EndHandle
** Input:       
** Output:        
** Created by:    ɽ
** Created Date:  2006-02-21
**-------------------------------------------------------------------------------------------------------
** Modified by:
** Modified Date: 
**------------------------------------------------------------------------------------------------------
********************************************************************************************************/
void StartCountT35(void)
{
	timeCount = 0;
	MBTimersActive(ENABLE);
}


/*******************************************************************************
* Function Name :void MBTimersInit(void)
* Description   :modbusЭõĶʱ ʼ:1.53.5ַڼʱ
* Input         :
* Output        :
* Other         :
* Date          :2012.05.21  13:48:15
*******************************************************************************/
void MBTimersInit(SLAVE_INFORMATION *DevicInfPtr)
{ 
	NVIC_InitTypeDef NvicInitdef;
	u16 cnt;
	TIM_TimeBaseInitTypeDef timbase;
	DEV_ERR err;

	if (DevicInfPtr->BaudRate > 192) 	//19200²ʰ ַʱ䴥ϰ250us
		cnt = (u16)(2.5e-4 * 1e6) * 2;
	else							// 0.5ֵַ 1ʼλ+8λ+ֹͣλ	
		cnt = (1 + 8 +DevicInfPtr->StopBit) * 1e6 /(DevicInfPtr->BaudRate * 100);		
	
	
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM4, ENABLE);	
	
	TIM_DeInit( TIM4 ); 
	timbase.TIM_CounterMode = TIM_CounterMode_Up;
	timbase.TIM_ClockDivision = TIM_CKD_DIV1;
	timbase.TIM_Period = cnt - 1;
	timbase.TIM_Prescaler = 72 - 1; 	// 72Ƶ
	TIM_TimeBaseInit( TIM4, &timbase );

	NvicInitdef.NVIC_IRQChannel = TIM4_IRQn;
	NvicInitdef.NVIC_IRQChannelPreemptionPriority = 4;
	NvicInitdef.NVIC_IRQChannelSubPriority = 0;
	NvicInitdef.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init( &NvicInitdef );

    _hUsart1 = UDFOpen(ID_USART1, DevicInfPtr, &err);
}


/*******************************************************************************
* Function Name :void TIM1_UP_IRQHandler(void)
* Description   :ʱжϺ
* Input         :
* Output        :
* Other         :
* Date          :2012.03.11  21:34:56
*******************************************************************************/
void TIM4_IRQHandler(void)
{
#ifdef UCOSIII
	OSIntEnter();
#endif
	if( RESET != TIM_GetITStatus(TIM4,TIM_IT_Update) )
	{
		TIM_ClearITPendingBit( TIM4, TIM_IT_Update);

		timeCount++;
		if (timeCount == 3)	// 1.5ַ 38400: 250us*3=750us
		{
			T15EndHandle();
		}
		else if (timeCount >= 7)	// 3.5ַ
		{
			T35EndHandle();
			MBTimersActive(DISABLE);	//Ҫʱرնʱ
		}
	}
#ifdef UCOSIII
	OSIntExit();
#endif
}



