/****************************************Copyright (c)**************************************************
**                                  Զ޹˾
**
**                                 http://www.21cm.com.cn
**
**
**--------------File Info-------------------------------------------------------------------------------
** File name:			MBSlave.c
** Last modified Date:  2005-01-11
** Last Version:		1.0
** Descriptions:		
**
**------------------------------------------------------------------------------------------------------
** Created by:			ZhouLishan
** Created date:		2005-01-11
** Version:				1.0
** Descriptions:		
**
**------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
** Version:
** Descriptions:
**
********************************************************************************************************/

#include "MBConfig.h"
#include	"modbus.h"



#ifdef UCOSIII
OS_SEM mb_handle_event_ptr;
static OS_ERR err;
volatile uint8 serialStatus = TRUE;
#endif



extern uint16 Modbus_CRC16(uint8 *Buff_addr, int16 len);

extern SendResponse(uint8 *buff,uint16 len);

// ܴ봦
extern AT_CODE FUNCTION_ARRAY	FCodeHandleArray[MAX_FUNCTION];			  


//********************************************************************************************************
// ƣMBSlaveIni
// DevicInfPtrӻϢݽṹָ
// 
// MODBUSӻʼ
//********************************************************************************************************
void MBSlaveIni(SLAVE_INFORMATION *DevicInfPtr)
{
	
	ADUData.Address = DevicInfPtr->Address;
	ADUData.ADUBuffPtr = DevicInfPtr->RequestPtr;
	ADUData.ADULength = 0;

//	ADUData.RedundancyCheck = 0;
	ADUData.EndT15 = FALSE;
	ADUData.FrameOK = FALSE;
	
	PDUData.PDUBuffPtr = NULL;
//	PDUData.Response.ExceptionCode = 0;

#ifdef UCOSIII
	OSSemCreate(	(OS_SEM 	*)&mb_handle_event_ptr, 
					(CPU_CHAR	*)"MODBUSź", 
					(OS_SEM_CTR)0, 
					(OS_ERR		*)&err);
#endif
}


//********************************************************************************************************
// ƣFunctionHandle
// 
// 
// 
//********************************************************************************************************
void FunctionHandle(void)
{
	uint8 i;
	PDU_RESPONSE Response;
	for(i=0;i<MAX_FUNCTION;i++)
	{
		if(FCodeHandleArray[i].Code==PDUData.FunctionCode)
		{
			Response.PDUDataPtr = PDUData.PDUBuffPtr;
			Response.PDUByteLength = PDUData.PDULength;

			FCodeHandleArray[i].Function( &Response );		// ִдݽṹָ
			
		//	PDUData.PDUBuffPtr = Response.PDUDataPtr;
			PDUData.PDULength = Response.PDUByteLength;
			PDUData.ExceptionCode = Response.ExceptionCode;
			return;
		}	
	}
	PDUData.ExceptionCode = EXCEPTION_CODE_1;	//	ܴЧ
}

void PackPDU2ADU(void)
{
	if(PDUData.ExceptionCode)	// ʧ
	{
		*PDUData.PDUBuffPtr = PDUData.FunctionCode|0x80;
		*(PDUData.PDUBuffPtr+1) = PDUData.ExceptionCode;
		PDUData.PDULength = 2;
	}
	ADUData.ADULength = PDUData.PDULength + 3;		// ADU = Adress + PDU + CRC/LRC = 1 + PDU + 2;
	
}

//********************************************************************************************************
// ƣTransfersReplyHandle
// 
// 
// Ӧ֡
//********************************************************************************************************
void TransfersReplyHandle(void)
{
	uint16	CRC_OR_LRC;
	*ADUData.ADUBuffPtr = ADUData.Address;	  								// 豸ַ
	CRC_OR_LRC = Modbus_CRC16(ADUData.ADUBuffPtr,ADUData.ADULength-2);		// CRC (ADUCRCǰ)
	*(ADUData.ADUBuffPtr+ADUData.ADULength-1) = (uint8)(CRC_OR_LRC/0x100);	// CRC Hi or LRC Hi 
	*(ADUData.ADUBuffPtr+ADUData.ADULength-2) = (uint8)CRC_OR_LRC;			// CRC Hi or LRC Hi 

	SendResponse(ADUData.ADUBuffPtr,ADUData.ADULength);
}


#include	"app.h"
#include	<string.h>
#include "MB_AddrTable.h"



//********************************************************************************************************
// ƣFunctionHandle
// 
// 
// MODBUS
//********************************************************************************************************
void IdleModbus(void)
{
#ifdef UCOSIII
    OS_ERR err;
    uint8 *pVal;

	// Ч֡
	OSSemPend(	(OS_SEM		*)&mb_handle_event_ptr,
				(OS_TICK	)4000,
				(OS_OPT		)OS_OPT_PEND_BLOCKING,
				(CPU_TS		*)0,
				(OS_ERR		*)&err	);
	if (err == OS_ERR_TIMEOUT)
		serialStatus = FALSE;
#endif	

	if(PDUData.FrameOK==FALSE)		// ֡δ
		return;
	
	PDUData.FrameOK = FALSE;
	FunctionHandle();				// ܴ봦
	PackPDU2ADU();					// PDU֡װADU֡
	TransfersReplyHandle();			// Ӧ֡
	// ׼յһ֡

//	ADUData.ADUBuffPtr = SlaveDevice.RequestPtr;
	ADUData.ADULength = 0;
	PDUData.PDUBuffPtr = NULL;

	serialStatus = TRUE;
	
#ifdef UCOSIII
	pVal = OSMemGet(&osMem, &err);
	if (err == OS_ERR_NONE)
	{
	    memcpy(pVal, mbBuff, sizeof(mbBuff));
	    OSTaskQPost(&taskFlashTCB, pVal, sizeof(mbBuff), OS_OPT_POST_1, &err);
	}
#endif	

}








