#ifndef _DrvSPI2_h_
#define _DrvSPI2_h_
#include "stm32f10x_spi.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"
#include "misc.h"
#include "Api.h"
#include <string.h>

/*----------------------------------------------------------------------------*/


#define SPIx 							SPI2				//ʹõSPI
#define RCC_APBXPeriph_SPIx			RCC_APB1Periph_SPI2		//SPI2ʱ
#define RCC_APBXPeriph_GPIOX_MISO	RCC_APB2Periph_GPIOB	//
#define RCC_APBXPeriph_GPIOX_MOSI	RCC_APB2Periph_GPIOB	//
#define RCC_APBXPeriph_GPIOX_CLK	RCC_APB2Periph_GPIOB	//


#define GPIOX_MISO	 				GPIOB
#define GPIOX_MOSI					GPIOB
#define GPIOX_CLK					GPIOB


#define GPIOX_PIN_MISO				GPIO_Pin_15				//
#define GPIOX_PIN_MOSI				GPIO_Pin_14				//
#define GPIOX_PIN_CLK				GPIO_Pin_13				//

#define SPIx_IRQHandler				SPI2_IRQHandler
#define SPIx_IRQChannel				SPI2_IRQn


#define RCC_APBXPeriph_GPIOX		(RCC_APBXPeriph_GPIOX_MISO |\
									RCC_APBXPeriph_GPIOX_MOSI |\
									RCC_APBXPeriph_GPIOX_CLK  )
									

#define SPIxInstall                 SPI2Install
#define SPIxNuinstall               SPI2Nuinstall

/*----------------------------------------------------------------------------*/


/*******************************************************************************
* Description   :SPIʼ SPI
* Input         :Ч NULL
*******************************************************************************/
static INT32S SPIxOpen(void *pd);
/*******************************************************************************
* Description   :ʧܴ
* Input         :Ч NULL
*******************************************************************************/
static INT32S SPIxClose(void *pd);
/*******************************************************************************
* Description   :һַ
* Input         :*buffer:塣lenToWrite:ݵĳ(ֽ)
*******************************************************************************/
static INT32S SPIxWrite(INT8S *buffer, INT32U lenToWrite, INT8U waitType);
/*******************************************************************************
* Description   :ȡ
* Input         :*buffer:塣lenToRead:ݵĳ(ֽ)
*******************************************************************************/
static INT32S SPIxRead(INT8S *buffer, INT32U blen, INT32U lenToRead, INT8U waitType);
/*******************************************************************************
* Description   :SPIX
* Input         :too: 	*pd
*				 0		INT16U	жȼ8λռȼ8λȼ
*				 0x10	void (*)(void)͵жϺ
*******************************************************************************/
static INT32S SPIxIoCtl(INT32U too, void *pd);




INT32S SPIxInstall(UDFOperationsType *op);
INT32S SPIxNuinstall(UDFOperationsType *op);





#endif



