#ifndef _DrvDACx_h_
#define _DrvDACx_h_
#include "stm32f10x_dac.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"
#include "Api.h"
#include <string.h>

/*----------------------------------------------------------------------------*/

#define DACx 					DAC						//ʹõDAC
#define RCC_APBXPeriph_DACx	RCC_APB1Periph_DAC		//DAC1ʱ
#define RCC_APBXPeriph_GPIOX	RCC_APB2Periph_GPIOA	//

#define DACx_GPIOX_1			GPIOA
#define DACx_GPIOX_2			GPIOA
#define DACx_GPIOX_PIN_CH1		GPIO_Pin_4				//ͨ˿1
#define DACx_GPIOX_PIN_CH2		GPIO_Pin_5				//ͨ˿2

#define DAC_CHANNEL_1_EN		1						//ͨ1ʹ
#define DAC_CHANNEL_2_EN		1						//ͨ2ʹ

#define DACxInstall				DACInstall
#define DACxNuinstall				DACNuinstall
/*----------------------------------------------------------------------------*/







/*******************************************************************************
* Description   :ʹDACģ
* Input         :Ч
*******************************************************************************/
static s32 DACxOpen(void *pd);
/*******************************************************************************
* Description   :رDACģ
* Input         :Ч
*******************************************************************************/
static s32 DACxClose(void *pd);
/*******************************************************************************
* Description   :DACX
* Input         :too: 	*pd
*				 1 		1ͨDAֵ	:16
*				 2 		2ͨDAֵ
*******************************************************************************/
static s32 DACxIoCtl(u32 too, void *pd);



s32 DACxInstall(UDFOperationsType *op);
s32 DACxNuinstall(UDFOperationsType *op);



#endif



