#ifndef _Drv25LC640_h_
#define _Drv25LC640_h_
#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"
#include "Api.h"
#include <string.h>



/*-----------------------------ֲĶ-----------------------------------*/

#define RCC_APBXPeriph_GPIOX_STE	RCC_APB2Periph_GPIOC	//Ƭѡ 
#define RCC_APBXPeriph_GPIOX_SOMI	RCC_APB2Periph_GPIOB	//ӻ 
#define RCC_APBXPeriph_GPIOX_WE	RCC_APB2Periph_GPIOC	//д
#define RCC_APBXPeriph_GPIOX_CLK	RCC_APB2Periph_GPIOB	//ʱ
#define RCC_APBXPeriph_GPIOX_SIMO	RCC_APB2Periph_GPIOB	//ӻ 

#define GPIOX_STE			GPIOC
#define GPIOX_SOMI			GPIOB
#define GPIOX_WE			GPIOC
#define GPIOX_CLK			GPIOB
#define GPIOX_SIMO			GPIOB

#define GPIOX_PIN_STE		GPIO_Pin_7				//
#define GPIOX_PIN_SOMI		GPIO_Pin_14				//
#define GPIOX_PIN_WE		GPIO_Pin_6				//
#define GPIOX_PIN_CLK		GPIO_Pin_13				//
#define GPIOX_PIN_SIMO		GPIO_Pin_15				//

#define EepromInstall		EepromInstall
#define EepromNuinstall		EepromNuinstall
/*----------------------------------------------------------------------------*/


#define RCC_APBXPeriph_GPIOX		(RCC_APBXPeriph_GPIOX_STE |\
									RCC_APBXPeriph_GPIOX_SOMI |\
									RCC_APBXPeriph_GPIOX_WE |\
									RCC_APBXPeriph_GPIOX_CLK |\
									RCC_APBXPeriph_GPIOX_SIMO )
									
#define    SelectChip()    {GPIO_ResetBits(GPIOX_STE, GPIOX_PIN_STE);}
#define    DeSelectChip()  {GPIO_SetBits(GPIOX_STE, GPIOX_PIN_STE);}

//=========================
//	EEPROM CMD
//=========================
 #define READ	0x03		//read data from momery
 #define WRITE	0x02		//write data to momery
 #define WRDI	0x04		//reset the write enable latch(disable write operation)
 #define WREN	0x06		//set the write enable latch(enable write operation)
 #define RDSR	0x05		//Read Status register
 #define WRSR	0x01		//Write Status register
 
#define	ROM_BLOCK_SIZE	32
#define	ROM_TOTAL_SIZE	0xFFF

 /*----------------------------------------------------------------------------*/




/*******************************************************************************
* Description   :ⲿ洢оƬ25LC640ͨŶ˿ڳʼ
* Input         :Ч
*******************************************************************************/
static INT32S EepromOpen(void *pd);
/*******************************************************************************
* Description   :дݵⲿ洢оƬ25LC640
* Input         :buffer:ҪдݡlenToWriter:ݳ(ֽ)
*******************************************************************************/
static INT32S EepromWrite(INT8S *buffer, INT32U lenToWrite, INT8U waitType);
/*******************************************************************************
* Description   :ⲿ洢оƬ25LC640 洢
* Input         :buffer:ݻlenToRead:ݳ(ֽ)
*******************************************************************************/
static INT32S EepromRead(INT8S *buffer, INT32U blen, INT32U lenToRead, INT8U waitType);


 
INT32S EepromInstall(UDFOperationsType *op);
INT32S EepromNuinstall(UDFOperationsType *op);




#endif



