
#ifndef _MB_AddrTable_h
#define _MB_AddrTable_h

#include "MBConfig.h"


typedef enum
{
	MB_TypeDiscrete,
	MB_TypeCoil,
	MB_TypeHoldingReg,
	MB_TypeInputReg,
}MB_ValueType;

typedef struct
{
	uint16 strat;
	uint16 end;
	MB_ValueType type;
	const void* fun;
}MB_RegOPtable;



/*******************************************************************************
* Description   :ɢ ַӦıָ
*******************************************************************************/
uint8 *MB_GetDiscreteAddr(uint16 addr);

/*******************************************************************************
* Description   :Ȧ ַӦıָ
*******************************************************************************/
uint8 *MB_GetCoilsAddr(uint16 addr);

/*******************************************************************************
* Description   :ñּĴ ַӦıָ
*******************************************************************************/
uint16 *MB_GetHoldingRegAddr(uint16 addr);

/*******************************************************************************
* Description   :Ĵ ַӦıָ
*******************************************************************************/
uint16 *MB_GetInputRegAddr(uint16 addr);

extern uint8 mbBuff[0x404];

#endif


