/****************************************Copyright (c)**************************************************
**                                  Զ޹˾
**
**                                 http://www.21cm.com.cn
**
**
**--------------File Info-------------------------------------------------------------------------------
** File name:			MBMaster.c
** Last modified Date:  2005-01-11
** Last Version:		1.0
** Descriptions:		
**
**------------------------------------------------------------------------------------------------------
** Created by:			ZhouLishan
** Created date:		2005-01-11
** Version:				1.0
** Descriptions:		
**
**------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
** Version:
** Descriptions:
**
********************************************************************************************************/
#include "MBConfig.h"

#define ERR_ADRRESS 	0xff		// 豸ַЧ
#define ERR_PARAMETER	0xfe		// Ч

#define ERR_TIMEOUT		0xfd		// ûӦʱ
#define ERR_FRAME		0xfc		// յ֡CRC
#define ERR_NON			0x00		// 


#define MB_POLL_TIMEOUT		100
#define MB_POLL_DELAY		5


extern FUNCTION_PACK_PDU FunPDUPackHanlde[MAX_FUNCTION];
extern FUNCTION_DATA_HANDLE FunParRepAndStData[MAX_FUNCTION];

uint16 Modbus_CRC16(uint8 *Buff_addr, int16 len);
void SendResponse(uint8 *buff,uint16 len);

//*****************************************************************************
// ƣ
// 
// 
// 
//*****************************************************************************


uint8 ADUBuffer[256];

extern g_WaitN10mS;

#ifdef UCOSIII
OS_SEM	mb_handle_event_ptr;
OS_Q	mb_reply_event_ptr;
OS_SEM	mb_idle_event_ptr;
static OS_ERR	err;
#endif

MASTER_INFORMATION MB_Master;
//********************************************************************************************************
// ƣMBSlaveIni
// 
// 
// MODBUSӻʼ
//********************************************************************************************************
void MBMasterIni(void)
{

	MB_Master.Status = MB_MASTER_IDLE;	// 
	ADUData.Address = 0;
	ADUData.ADUBuffPtr = ADUBuffer;
	ADUData.ADULength = 0;

//	ADUData.RedundancyCheck = 0;
	ADUData.EndT15 = FALSE;
	ADUData.FrameOK = FALSE;
//	ADUData.OverTime = FALSE;
	PDUData.PDUBuffPtr = NULL;
//	PDUData.Response.ExceptionCode = 0;
#ifdef UCOSIII

	OSSemCreate(	(OS_SEM 	*)&mb_reply_event_ptr, 
					(CPU_CHAR	*)"MODBUSӦϢ", 
					(OS_SEM_CTR)0, 
					(OS_ERR		*)&err);

					
	OSSemCreate(	(OS_SEM 	*)&mb_idle_event_ptr, 
					(CPU_CHAR	*)"MODBUSź", 
					(OS_SEM_CTR)1, 
					(OS_ERR		*)&err);
					
	OSSemCreate(	(OS_SEM 	*)&mb_handle_event_ptr, 
					(CPU_CHAR	*)"MODBUSź", 
					(OS_SEM_CTR)0, 
					(OS_ERR		*)&err);
	
#endif
}


//******************************************************************************************
// ƣModbusPoll
// NodeID,ڵID豸ַ
// 			 FunctionCodeܴ
//			 ParameterPtr
// err,ִָ״̬
// 
//******************************************************************************************

uint8 ModbusPoll(uint8 NodeID,uint8 FunctionCode,void *ParameterPtr)
{
	uint8 i;
	ADUData.Address = NodeID;
	

	for(i=0;i<MAX_FUNCTION;i++)							// ЧĹܴ			
	{	if(FunPDUPackHanlde[i].Code==FunctionCode)		// ҹܴ봦
		{
		#ifdef UCOSIII
			// ȴԲMODBUSһź	
			OSSemPend(	(OS_SEM		*)&mb_idle_event_ptr,
						(OS_TICK	)0,
						(OS_OPT		)OS_OPT_PEND_BLOCKING,
						(CPU_TS		*)0,
						(OS_ERR		*)&err	);			
		#else
			if(MB_Master.Status!=(uint8)MB_MASTER_IDLE)
				return (uint8)MB_MASTER_BUSY;			// Чָ
		#endif	
			PDUData.PDUBuffPtr = ADUData.ADUBuffPtr+1;	// PDUʼָ
			FunPDUPackHanlde[i].Function(ParameterPtr);	// ùܴ봦
			PDUData.FrameOK = TRUE;						// ֡׼
			MB_Master.ParPtr = ParameterPtr;			// ṹָ
			
		#ifdef UCOSIII
			// ź,ʹMODBUS
			OSSemPost(	(OS_SEM		*)&mb_handle_event_ptr,
						(OS_OPT		)OS_OPT_POST_NO_SCHED,
						(os_err		*)&err	);				
						
			// ȴִ	
			OSSemPend(	(OS_SEM		*)&mb_reply_event_ptr,
						(OS_TICK	)0,
						(OS_OPT		)OS_OPT_PEND_BLOCKING,
						(CPU_TS		*)0,
						(OS_ERR		*)&err	);
		#else
			do
			{
				err = IdleModbus();
			}while(MB_Master.Status==(uint8)MB_MASTER_BUSY);
		#endif		
			return err;	// Чָ

		}
	}
	return (uint8)MB_FUN_NOT_DEF;
}


//******************************************************************************************
// ƣParseReponseAndStoreData
// 
// 
// Ӧ֡
//******************************************************************************************
uint8 ParseReponseAndStoreData(void)
{
	uint8 i,err;
	err = MB_FUN_NOT_DEF;
	for(i=0;i<MAX_FUNCTION;i++)							
		if(FunParRepAndStData[i].Code==PDUData.FunctionCode)		// ҹܴ봦
		{
			if(PDUData.PDUBuffPtr[0]&0x80)	// 쳣
			{	err = PDUData.PDUBuffPtr[1];}
			else	
			{	err = MB_NO_ERR;
				FunParRepAndStData[i].Function(PDUData.PDUBuffPtr,MB_Master.ParPtr);	// ùܴ봦
			}
			break;
		}
	return err;// δ幦
}

//******************************************************************************************
// ƣCheckModbusMessage
// 
// ADU
// ǷҪ͵ĵ֡
//******************************************************************************************
ADU_CONTROL *CheckModbusMessage(void)
{
	uint16 CRC16;
	uint8 *ADUPtr;
	if(PDUData.FrameOK == TRUE)			// ֡PDUǷ׼
	{
		PDUData.FrameOK = FALSE;		// PDUǷ׼־յЧPDU󽫱ٴ1
		ADUPtr = ADUData.ADUBuffPtr;
		ADUPtr[0] = ADUData.Address;	// ADUַڵ㣩
		
		CRC16 = Modbus_CRC16(ADUPtr,PDUData.PDULength+1);	// CRC16ֵ
		ADUPtr[PDUData.PDULength+1] = CRC16;				// CRC16ֵ
		ADUPtr[PDUData.PDULength+2] = CRC16>>8;
		ADUData.ADULength=PDUData.PDULength+3;		// ADUȵPDUȼ1ַ2CRCַ
		ADUData.FrameOK = TRUE;						// ADU֡׼
		
		return (ADU_CONTROL *) &ADUData;			
	}
	else
		return NULL;
}








//******************************************************************************************
// ƣIdleModbus
// 
// MODBUS״̬
// 
//******************************************************************************************
uint8 IdleModbus(void)
{
	static uint8  modbus_state=0;
	
#ifdef	UCOSIII
	OSSemPend(	(OS_SEM		*)&mb_handle_event_ptr,
				(OS_TICK	)0,
				(OS_OPT		)OS_OPT_PEND_BLOCKING,
				(CPU_TS		*)0,
				(OS_ERR		*)&err	);
#endif	
	
	err = MB_MASTER_BUSY;
	switch ( modbus_state )
	{
      	case 0:
         	/******************************************************************/
         	/*       CHECK FOR THE NEXT MESSAGE TO SEND                       */
         	/*       Ҫ͵Ϣ֡						  */
         	/******************************************************************/
        	if ( CheckModbusMessage() )
			{     
				/******************************************************************/
	         	/*       SEND THE POLL                                            */
	         	/*		֡												  */
	         	/******************************************************************/
	         	SendResponse(ADUData.ADUBuffPtr,ADUData.ADULength);// ֡
	        	ADUData.FrameOK = FALSE;
	        	ADUData.ADULength = 0;
   				MB_Master.Status = (uint8)MB_MASTER_BUSY;				// æ״̬
	        	Waite10mS(MB_POLL_TIMEOUT);			// Ӧʱ 
	            modbus_state++;
 				
            }
            else
            	err = MB_MASTER_IDLE;	// ûйܴ贫
         	break;
      	case 1:
         	/******************************************************************/
         	/*       GET THE PACKET AND MAKE SURE IT IS COMPLETE              */
         	/******************************************************************/
         	if ( PDUData.FrameOK )	// ɹPDU֡
            {
                /******************************************************************/
         		/*       PARSE THE RESPONSE AND STORE THE DATA                    */
         		/*       Ӧ֡									  */
         		/******************************************************************/
         		err = ParseReponseAndStoreData();
         		PDUData.FrameOK = FALSE;
         		Waite10mS(MB_POLL_DELAY);	
    		#ifdef	UCOSIII   
				OSSemPost(	(OS_SEM		*)&mb_reply_event_ptr,
							(OS_OPT		)OS_OPT_POST_ALL,
							(os_err		*)&err	);
		#endif		 
            	modbus_state++;
            	break;
            }

         	/******************************************************************/
         	/*       IF NO RESPONSE RECEIVED TIME OUT AND SEND NEXT POLL      */
         	/******************************************************************/
         	if (g_TimeEnd)
            {
            	modbus_state = 0;
            	MB_Master.Status = MB_MASTER_IDLE;	// 
            	err = MB_RESPONSE_TIME_OUT;
 			#ifdef	UCOSIII
				OSSemPost(	(OS_SEM		*)&mb_reply_event_ptr,
							(OS_OPT		)OS_OPT_POST_ALL,
							(os_err		*)&err	);
			#endif	
            }
         	break;
      	case 2:
         	/******************************************************************/
         	/*       POLL DELAY                                               */
         	/*		ѭʱ												  */
         	/******************************************************************/

         	if (g_TimeEnd)
            {
               	modbus_state=0;
          		MB_Master.Status = MB_MASTER_IDLE;	// 
            }
      	default:
         	break;
      }
      
#ifdef	UCOSIII
	if(MB_Master.Status == MB_MASTER_IDLE)
		OSSemPost(	(OS_SEM		*)&mb_idle_event_ptr,
					(OS_OPT		)OS_OPT_POST_ALL,
					(os_err		*)&err	);
#endif
    return err;
}







