/****************************************Copyright (c)**************************************************
**                                  Զ޹˾
**
**                                 http://www.21cm.com.cn
**
**
**--------------File Info-------------------------------------------------------------------------------
** File name:			OSFUNfile.c
** Last modified Date:  2005-01-11
** Last Version:		1.0
** Descriptions:		
**
**------------------------------------------------------------------------------------------------------
** Created by:			ZhouLishan
** Created date:		2005-01-11
** Version:				1.0
** Descriptions:		
**
**------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
** Version:
** Descriptions:
**
********************************************************************************************************/
#include "config.h"


//*********************************************************************************
// ƣOSReadCoils
// IDӻַ
//			 StartAddressȦʼַ(0x0000~0xffff)
//			 QuantityȦ(0x001~0x07d0)
//			 ReaValuePtrȦֵָ
// ɴ룺(쳣)
// ȡȦֵ0x01
//*********************************************************************************
 uint8 OSReadCoils(uint8 ID, 
 					 uint16 StartAddress,
 					 uint16 Quantity,
 					 uint8 *ReaValuePtr)		
{
	READ_PARAMET Parameter;
	Parameter.RStartAddr = StartAddress;
   	Parameter.RQuantity = Quantity;
    Parameter.DataPtr = (uint16 *)ReaValuePtr;
    return ModbusPoll(ID,0x01,&Parameter);
}

//*********************************************************************************
// ƣOSReadDisInputs
// IDӻַ
//			 StartAddressɢʼַ(0x0000~0xffff)
//			 Quantityɢ(0x001~0x07d0)
//			 ReaValuePtrɢֵָ
// ɴ룺(쳣)
// ȡɢֵ0x02
//*********************************************************************************
 uint8 OSReadDisInputs(uint8 ID, 
 					 uint16 StartAddress,
 					 uint16 Quantity,
 					 uint8 *ReaValuePtr)		
{
	READ_PARAMET Parameter;
	Parameter.RStartAddr = StartAddress;
   	Parameter.RQuantity = Quantity;
    Parameter.DataPtr = (uint16 *)ReaValuePtr;
    return ModbusPoll(ID,0x02,&Parameter);
}

//*********************************************************************************
// ƣOSReadHoldReg
// IDӻַ
//			 StartAddressĴʼַ(0x0000~0xffff)
//			 QuantityĴ(0x0001~0x007d)
//			 ReaValuePtrĴֵָ
// ɴ룺(쳣)
// ȡּĴֵ0x03
//*********************************************************************************
 uint8 OSReadHoldReg(uint8 ID, 
 					 uint16 StartAddress,
 					 uint16 Quantity,
 					 uint16 *ReaValuePtr)		// ּĴ
{
	READ_PARAMET Parameter;
	Parameter.RStartAddr = StartAddress;
   	Parameter.RQuantity = Quantity;
    Parameter.DataPtr =  ReaValuePtr;
    return ModbusPoll(ID,0x03,&Parameter);
}

//*********************************************************************************
// ƣOSReadInputReg
// IDӻַ
//			 StartAddressĴʼַ(0x0000~0xffff)
//			 QuantityĴ(0x0001~0x007d)
//			 ReaValuePtrĴֵָ
// ɴ룺(쳣)
// ȡĴֵ0x04
//*********************************************************************************
 uint8 OSReadInputReg(uint8 ID, 
 					 uint16 StartAddress,
 					 uint16 Quantity,
 					 uint16 *ReaValuePtr)		
{
	READ_PARAMET Parameter;
	Parameter.RStartAddr = StartAddress;
   	Parameter.RQuantity = Quantity;
    Parameter.DataPtr =  ReaValuePtr;
    return ModbusPoll(ID,0x04,&Parameter);
}

//*********************************************************************************
// ƣOSWriteSingleCoil
// IDӻַ
//			 OutAddressдĵַ(0x0000~0xffff)
//			 OutValueдֵCOIL_OFF(0x0000)COIL_ON(0xff00)
// ɴ룺(쳣)
// дȦ0x05
//*********************************************************************************
 uint8 OSWriteSingleCoil(uint8  ID,
 						 uint16 OutAddress,
 						 uint16 OutValue)
{
	WRITE_PARAMET Parameter;
	Parameter.WStartAddr = OutAddress;
	Parameter.DataPtr = &OutValue;
    return ModbusPoll(ID,0x05,&Parameter);
}

//*********************************************************************************
// ƣOSWriteSingleReg
// IDӻַ
//			 OutAddressдĵַ(0x0000~0xffff)
//			 OutValueдֵ(0x0000~0xffff)
// ɴ룺(쳣)
// дĴ0x06
//*********************************************************************************
 uint8 OSWriteSingleReg(uint8  ID,
 						 uint16 OutAddress,
 						 uint16 OutValue)
{
	WRITE_PARAMET Parameter;
	Parameter.WStartAddr = OutAddress;
	Parameter.DataPtr = &OutValue;
    return ModbusPoll(ID,0x06,&Parameter);
}

//*********************************************************************************
// ƣOSWriteMultipleCoils
// IDӻַ
//			 StartAddressдĵַ(0x0001~0xffff)
//			 Quantityд(0x0001~0x07b0)
//			 ValuePtrдݵָ
// ɴ룺(쳣)
// дȦ0x0f
//*********************************************************************************
uint8  OSWriteMultipleCoils(uint8 ID, 
 					 	uint16 StartAddress,
 					 	uint16 Quantity,
 					 	uint8 *ValuePtr)	
{
	WRITE_PARAMET Parameter;
	Parameter.WStartAddr = StartAddress;
   	Parameter.WQuantity = Quantity;
    Parameter.DataPtr =  (uint16*)ValuePtr;
    return ModbusPoll(ID,0x0f,&Parameter);
}

//*********************************************************************************
// ƣWriteMultipleReg
// IDӻַ
//			 StartAddressдĵַ(0x0001~0xffff)
//			 Quantityд(0x0001~0x0078)
//			 ValuePtrдݵָ
// ɴ룺(쳣)
// дĴ0x10
//*********************************************************************************
uint8  OSWriteMultipleReg(uint8 ID, 
 					 	uint16 StartAddress,
 					 	uint16 Quantity,
 					 	uint16 *ValuePtr)	
{
	WRITE_PARAMET Parameter;
	Parameter.WStartAddr = StartAddress;
   	Parameter.WQuantity = Quantity;
    Parameter.DataPtr =  ValuePtr;
    return ModbusPoll(ID,0x10,&Parameter);
}

//*********************************************************************************
// ƣMaskWriteReg
// IDӻַ
//			 Addrдĵַ(0x0001~0xffff)
//			 And_Maskд
//			 Or_Maskд
// ɴ룺(쳣)
// дĴOr_MaskֵΪ㣬ôǵǰݺAnd_Maskļ߼AND룩
//			 And_MaskֵΪ㣬Or_Maskֵ0x16
//*********************************************************************************
uint8  OSMaskWriteReg(uint8 ID, 
 					uint16 Addr,
 					uint16 And_Mask,
 					uint16 Or_Mask)	
{
	MASK_WRITE_REG Parameter;
	Parameter.RefAddress = Addr;
   	Parameter.And_Mask = And_Mask;
    Parameter.OR_Mask =  Or_Mask;
    return ModbusPoll(ID,0x16,&Parameter);
}


//*********************************************************************************
// ƣReadWriteMultipleReg2PDU
// IDӻַ
//			 WStartAddrдĴĵַ(0x0001~0xffff)
//           WQuantityдĴ(1~121)
//			 RStartAddrĴĵַ(0x0001~0xffff)
//			 RQuantityĴ(1~125)
//			 DataPtrдĴָͶݴָ
// ɴ룺(쳣)
// дĴ0x17
//*********************************************************************************
uint8  OSReadWriteMultipleReg(uint8 ID, 
 					 	uint16 WStartAddr,
 					 	uint16 WQuantity,
 					 	uint16 RStartAddr,
 					 	uint16 RQuantity,
 					 	uint16 *DataPtr)	
{
	WRITE_PARAMET Parameter;
	
	if(RQuantity>125)
		return MB_PARAMETER_ERR;
	if(WQuantity>121)
		return MB_PARAMETER_ERR;
 	Parameter.RStartAddr = RStartAddr;
 	Parameter.RQuantity = RQuantity;
 	Parameter.WStartAddr = WStartAddr;
 	Parameter.WQuantity = WQuantity;
  	Parameter.DataPtr = DataPtr;
    return ModbusPoll(ID,0x17,&Parameter);
}



