/****************************************Copyright (c)**************************************************
**                                  Զ޹˾
**
**                                 http://www.21cm.com.cn
**
**
**--------------File Info-------------------------------------------------------------------------------
** File name:			MBSlave.h
** Last modified Date:  2005-01-11
** Last Version:		1.0
** Descriptions:		
**
**------------------------------------------------------------------------------------------------------
** Created by:			ZhouLishan
** Created date:		2005-01-11
** Version:				1.0
** Descriptions:		
**
**------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
** Version:
** Descriptions:
**
********************************************************************************************************/

#ifndef __MBSLAVE_H
#define __MBSLAVE_H
#include    "modbus.h"
/***************************************************
** ʹMODBUSܴ
****************************************************/
#define	READ_COILS_EN		1	// Ȧ
#define	READ_DIS_INPUT_EN	1	// ɢ
#define	READ_HOLD_REG_EN	1	// ּĴ
#define	READ_INPUT_REG_EN	1	// Ĵ
#define	WRITE_SING_COIL_EN	1	// дȦ
#define	WRITE_SING_REG_EN	1	// дĴ
#define	WRITE_MULT_COIL_EN	1	// дȦ
#define	WRITE_MULT_REG_EN	1	// дĴ
#define	MASK_WRITE_REG_EN	1	// μĴָ
#define	READ_WRITE_REG_EN	1	// дĴ


/***************************************************
** ȦĲȦ
****************************************************/
#define END_COILS_ADDR			100
/***************************************************
** ɢĲɢ
****************************************************/
#define END_DISC_INPUT_ADDR		100
/***************************************************
** ĴĲĴ
****************************************************/
#define END_INPUT_REG_ADDR		123
/***************************************************
** ñּĴĲ屣ּĴ
****************************************************/
#define END_HOLDING_REG_ADDR	1028			



#define	MAX_FUNCTION		(READ_COILS_EN     	+\
							 READ_DIS_INPUT_EN	+\
							 READ_HOLD_REG_EN	+\
							 READ_INPUT_REG_EN	+\
							 WRITE_SING_COIL_EN	+\
							 WRITE_SING_REG_EN	+\
							 WRITE_MULT_COIL_EN	+\
							 WRITE_MULT_REG_EN	+\
							 MASK_WRITE_REG_EN	+\
							 READ_WRITE_REG_EN	+\
							 1)

/* ӻ */
typedef struct __SLAVE_INFORMATION{
	uint8   	Address;		  			// ַ
	uint8	LineProtocol;	  			// ·Э
	uint16	BaudRate;	  				//  = BaudRate * 100	

	uint8	Parity;						// żУ
	uint8	StopBit;						// ֹͣλ 

	uint8*	RequestPtr;					// ָ֡
}SLAVE_INFORMATION;

// ӻϢ
extern SLAVE_INFORMATION SlaveDevice;

// ܴṹ
typedef struct __FUNCTION_ARRAY{
	uint8	 Code;
	void	 (*Function)(PDU_RESPONSE *Response);
}FUNCTION_ARRAY;



void MBSlaveIni(SLAVE_INFORMATION *DevicInfPtr);
void IdleModbus(void);

#endif



