#ifndef _DrvTime3_h_
#define _DrvTime3_h_

#include "stm32f10x_tim.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"
#include "misc.h"
#include "Api.h"
#include <string.h>


/*-----------------------------ֲĶ-----------------------------------*/

#define TIMX 					TIM3					//ʹõļ
#define RCC_APBXPeriph_GPIOX_1  RCC_APB2Periph_GPIOA	//ʱ
#define RCC_APBXPeriph_GPIOX_2  RCC_APB2Periph_GPIOB	//
#define RCC_APBXPeriph_TIMX     RCC_APB1Periph_TIM3		//ʱʱ
#define TIMX_GPIOX_1            GPIOA
#define TIMX_GPIOX_2            GPIOB
#define TIMX_GPIOX_PIN_CC1      GPIO_Pin_6				//ͨ˿GPIOX_1
#define TIMX_GPIOX_PIN_CC2      GPIO_Pin_7				//ͨ˿GPIOX_1
#define TIMX_GPIOX_PIN_CC3      GPIO_Pin_0				//ͨ˿GPIOX_2
#define TIMX_GPIOX_PIN_CC4      GPIO_Pin_1				//ͨ˿GPIOX_2

#define TIMX_IRQHandler         TIM3_IRQHandler
#define TIMX_IRQChannel         TIM3_IRQn

#define TIM_OCMode_PWMX         TIM_OCMode_PWM1		//ʹõpwmģʽ
#define TIM_OCPolarity_H_L		TIM_OCPolarity_High		//PWMЧƽΪ߻ǵ

#define TIMX_PWM_CC1_EN         1	//timxPwm1ͨ1  1:ܣ0:ʧ
#define TIMX_PWM_CC2_EN         1	//timxPwm2ͨ2  1:ܣ0:ʧ
#define TIMX_PWM_CC3_EN         1	//timxPwm3ͨ3  1:ܣ0:ʧ
#define TIMX_PWM_CC4_EN         1	//timxPwm4ͨ4  1:ܣ0:ʧ
			
#define TIMX_INTERRUPT_EN       1	//TIMXжʹ
#define TIMX_IRQ_FREQ           100	//ʱжƵ

#define TimXInstall             Tim3Install
#define TimXNuinstall           Tim3Nuinstall

/*----------------------------------------------------------------------------*/
//PWM
#define TIMX_PWM_EN			    (TIMX_PWM_CC1_EN + TIMX_PWM_CC2_EN+ \
								    TIMX_PWM_CC3_EN + TIMX_PWM_CC4_EN)



/*----------------------------------------------------------------------------*/


/*******************************************************************************
* Function Name :s32 TimXOpen(void *pd)
* Description   :ʹtimXʱ
* Input         :*pd Ƶ u32
* Output        :
* Other         :
* Date          :2012.05.22  14:14:40
*******************************************************************************/
static s32 TimXOpen(void *pd);
/*******************************************************************************
* Function Name :s32 TimXClose(void *pd)
* Description   :timXʱ
* Input         :
* Output        :
* Other         :
* Date          :2012.05.22  15:25:36
*******************************************************************************/
static s32 TimXClose(void *pd);						
/*******************************************************************************
* Function Name :static s32 TimXIoCtl(u32 too, void *pd)
* Description   :timXʱ ռձȿ
* Input         :too:1-ͨ12-ͨ23-ͨ34-ͨ4.
				 too		                *pd
				 DEV_CTRL_NVIC_Priority	    жȼ8λռȼ8λȼ :int16
				 DEV_CTRL_DATA_1			ͨ1ռձȡλ() ȡֵΧ:0-1000  :int16
				 DEV_CTRL_DATA_2			ͨ2ռձȡλ() ȡֵΧ:0-1000  :int16
				 DEV_CTRL_DATA_3			ͨ3ռձȡλ() ȡֵΧ:0-1000  :int16
				 DEV_CTRL_DATA_4			ͨ4ռձȡλ() ȡֵΧ:0-1000  :int16
 				 DEV_CTRL_ISR_Fun		    жϷ  void(*)(void)

				
* Output        :ȡֵ  Чָ 
* Other         :
* Date          :2012.05.22  17:46:04
*******************************************************************************/
static s32 TimXIoCtl(u32 too, void *pd);





INT32S TimXInstall(UDFOperationsType *op);
INT32S TimXNuinstall(UDFOperationsType *op);



#endif


