/*
GUANFU_WANG@126.COM
QQ:21578936
δɽֹκҵ;
*/
/*
OV7725
*/
#include "ov7670.h"
#include "ov7670config.h"
#include "misc.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"
#include "stm32f10x_exti.h"
#include "bsp.h"



void ov7670_GPIO_Init(void)
{
  
  GPIO_InitTypeDef GPIO_InitStructure;
   // Enable GPIOC  clock
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD, ENABLE);
  GPIO_InitStructure.GPIO_Pin =  OV7670_VSYNC_BIT;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GPIOD, &GPIO_InitStructure);
 
}

/********************************************************************
ܣ7670ж
ڲޡ
    أޡ
    עޡ
********************************************************************/
void ov7670_Interrupts_Config(void)
{
  NVIC_InitTypeDef NVIC_InitStructure;

  
  /* Enable the EXTI9_5 Interrupt */
  NVIC_InitStructure.NVIC_IRQChannel = EXTI2_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
  

  

}



void OV7670_EXTI_Config(void)
{
  EXTI_InitTypeDef EXTI_InitStructure;
  GPIO_EXTILineConfig(GPIO_PORT_SOURCE_VSYNC_CMOS, GPIO_PIN_SOURCE_VSYNC_CMOS);
  EXTI_InitStructure.EXTI_Line = EXTI_LINE_VSYNC_CMOS;
  EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
  
  
  
  #if  (CMOS_MD==0 )
 EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Rising ;
#elif CMOS_MD==1
 EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Rising ;
#elif CMOS_MD==2
 EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling ;
#elif (CMOS_MD==3)
 EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling ;
#endif
 
  EXTI_InitStructure.EXTI_LineCmd = ENABLE;
  EXTI_Init(&EXTI_InitStructure);
  EXTI_GenerateSWInterrupt(EXTI_LINE_VSYNC_CMOS);

}



////////////////////////////
//ܣдOV7660Ĵ
//أ1-ɹ	0-ʧ
#if  (CMOS_MD==0 )|(CMOS_MD==1 )
    unsigned char wrOV7670Reg(unsigned char regID, unsigned char regDat)
    {
		startSCCB();
	if(0==SCCBwriteByte(0x42))
	{
		stopSCCB();
		return(0);
	}
	delay_us(100);
  	if(0==SCCBwriteByte(regID))
	{
		stopSCCB();
		return(0);
	}
	delay_us(100);
  	if(0==SCCBwriteByte(regDat))
	{
		stopSCCB();
		return(0);
	}
  	stopSCCB();
	
  	return(1);
     }
#elif (CMOS_MD==2 )|(CMOS_MD==3 )
   unsigned char wrOV7670Reg(unsigned char Page,unsigned char regID, unsigned int regDat)
   {     
      
        startSCCB();
	if(0==SCCBwriteByte(0xba))
	{
		stopSCCB();
		return(0);
	}
	delay_us(100);
  	if(0==SCCBwriteByte(0xf0))
	{
		stopSCCB();
		return(0);
	}
	delay_us(100);
  	if(0==SCCBwriteByte((unsigned char)( Page>>8)))
	{
		stopSCCB();
		return(0);
	}
        if(0==SCCBwriteByte((unsigned char)( Page)))
	{
		stopSCCB();
		return(0);
	}
        stopSCCB();
   //////////////////////////////////////////////////////////////     
	startSCCB();
	if(0==SCCBwriteByte(0xba))
	{
		stopSCCB();
		return(0);
	}
	delay_us(100);
  	if(0==SCCBwriteByte(regID))
	{
		stopSCCB();
		return(0);
	}
	delay_us(100);
  	if(0==SCCBwriteByte((unsigned char)(regDat>>8)))
	{
		stopSCCB();
		return(0);
	}
        
   	if(0==SCCBwriteByte((unsigned char)regDat))
	{
		stopSCCB();
		return(0);
	}
        
  	stopSCCB();
	
  	return(1);
}
#elif (CMOS_MD==4 )
    unsigned char wrOV7670Reg(unsigned char regID, unsigned char regDat)
    {
		startSCCB();
	if(0==SCCBwriteByte(0x60))
	{
		stopSCCB();
		return(0);
	}
	delay_us(100);
  	if(0==SCCBwriteByte(regID))
	{
		stopSCCB();
		return(0);
	}
	delay_us(100);
  	if(0==SCCBwriteByte(regDat))
	{
		stopSCCB();
		return(0);
	}
  	stopSCCB();
	
  	return(1);
     }
  #endif 
////////////////////////////
//ܣOV7660Ĵ
//أ1-ɹ	0-ʧ
unsigned char rdOV7670Reg(unsigned char regID, unsigned char *regDat)
{
	//ͨдüĴַ
	startSCCB();
	if(0==SCCBwriteByte(0x42))
	{
		stopSCCB();
		return(0);
	}
	delay_us(100);
  	if(0==SCCBwriteByte(regID))
	{
		stopSCCB();
		return(0);
	}
	stopSCCB();
	
	delay_us(100);
	
	//üĴַ󣬲Ƕ
	startSCCB();
	if(0==SCCBwriteByte(0x43))
	{
		stopSCCB();
		return(0);
	}
	delay_us(100);
  	*regDat=SCCBreadByte();
  	noAck();
  	stopSCCB();
  	return(1);
}




/* OV7670_init() */
//1ɹ0ʧ
unsigned char OV7670_init(void)
{
    unsigned char temp = 0;
	unsigned int i=0;

	//uchar ovidmsb=0,ovidlsb=0;
	ov7670_GPIO_Init();
	SCCB_GPIO_Config();//io init..
 #if   (CMOS_MD==0 )| (CMOS_MD==1 )|(CMOS_MD==4 )


	temp=0x80;
	if(0==wrOV7670Reg(0x12, temp)) //Reset SCCB
	{
          return 0 ;
	}
	Delay(50);

        
        for(i=0;i<CHANGE_REG_NUM;i++)
	{
		if( 0==wrOV7670Reg(change_reg[i][0],change_reg[i][1]))
		{
			return 0;
		}
	}
        //OV7670_config_window(272,16,320,240);
  #elif(CMOS_MD==2 )| (CMOS_MD==3)   
        for(i=0;i<CHANGE_REG_NUM;i++)
	{
	       if(change_reg[i][0]>2)
               {
                  Delay(change_reg[i][2]); // Delay 5ms();
               }
               else
               {
                  if( 0==wrOV7670Reg(change_reg[i][0],change_reg[i][1],change_reg[i][2]))
		  {
			return 0;
		  }
               }
             // delay_us(10);
	}
        
  #endif      
	return 0x01; //ok
} 

